package com.flashvisions.mobile.android.extensions.app.functions;

import java.io.IOException;

import android.app.Activity;
import android.graphics.Bitmap;
import android.util.DisplayMetrics;

import com.adobe.fre.FREBitmapData;
import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREInvalidObjectException;
import com.adobe.fre.FREObject;
import com.adobe.fre.FRETypeMismatchException;
import com.adobe.fre.FREWrongThreadException;
import com.flashvisions.mobile.android.extensions.app.WallpaperManagerExtensionContext;

public class SetWallpaperFromBitmapData implements FREFunction {

	@Override
	public FREObject call(FREContext context, FREObject[] args)
	{
		FREObject result = null;
		
		Boolean scale;
		FREBitmapData bmpdata = (FREBitmapData) args[0];
		int bmpWidth;
		int bmpHeight;
		Bitmap bitmap;
		Bitmap finalBitmap;
		
		WallpaperManagerExtensionContext wpc = (WallpaperManagerExtensionContext)context;
		Activity a = wpc.getActivity();
		
		DisplayMetrics metrics = new DisplayMetrics();
		a.getWindowManager().getDefaultDisplay().getMetrics(metrics);
		
		try {
			result = FREObject.newObject(false);
			
			scale = args[1].getAsBool();
			
			bmpdata.acquire();
			bmpWidth = bmpdata.getWidth();
			bmpHeight = bmpdata.getHeight();
			
		    bitmap = Bitmap.createBitmap(bmpWidth, bmpHeight, Bitmap.Config.ARGB_8888);
		    bitmap.copyPixelsFromBuffer(bmpdata.getBits());
		    
		    finalBitmap = (scale)?Bitmap.createScaledBitmap(bitmap, metrics.widthPixels, metrics.heightPixels, true):bitmap;
		    wpc.wallpapermanager.setBitmap(finalBitmap);
		    
		    bitmap.recycle();
		    bmpdata.release();
		    finalBitmap.recycle();
		    
			result = FREObject.newObject(true);
			
		} catch (IllegalStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FREInvalidObjectException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FREWrongThreadException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FRETypeMismatchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			bitmap = null;
			bmpdata = null;
			finalBitmap = null;
			metrics = null;
		}
		
		return result;
	}

}
