package com.flashvisions.mobile.android.extensions.app.functions;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.DisplayMetrics;

import com.adobe.fre.FREContext;
import com.adobe.fre.FREFunction;
import com.adobe.fre.FREInvalidObjectException;
import com.adobe.fre.FREObject;
import com.adobe.fre.FRETypeMismatchException;
import com.adobe.fre.FREWrongThreadException;
import com.flashvisions.mobile.android.extensions.app.WallpaperManagerExtensionContext;

public class SetWallpaperFromPath implements FREFunction {

	@Override
	public FREObject call(FREContext context, FREObject[] args) 
	{
		FREObject result = null;
		Boolean scale;
		FileInputStream is;
		BufferedInputStream bis;
		Bitmap bitmap;
		Bitmap useThisBitmap;
		
		WallpaperManagerExtensionContext wpc = (WallpaperManagerExtensionContext)context;
		Activity a = wpc.getActivity();
		
		DisplayMetrics metrics = new DisplayMetrics();
		a.getWindowManager().getDefaultDisplay().getMetrics(metrics);
		
		
		try {
			result = FREObject.newObject(false);
			scale = args[1].getAsBool();
			
			is = new FileInputStream(new File(args[0].getAsString()));
			bis = new BufferedInputStream(is);
			bitmap = BitmapFactory.decodeStream(bis);
			useThisBitmap = (scale)?Bitmap.createScaledBitmap(bitmap, metrics.widthPixels, metrics.heightPixels, true):bitmap;
			
			wpc.wallpapermanager.setBitmap(useThisBitmap);
			
			bitmap.recycle();
			useThisBitmap.recycle();
			
			result = FREObject.newObject(true);
			
		} catch (IllegalStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FRETypeMismatchException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FREInvalidObjectException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FREWrongThreadException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally{
			is = null;
			bis = null;
			useThisBitmap = null;
			bitmap = null;
			metrics = null;
		}
		
		return result;
	}

}
